using System.Collections.ObjectModel;
using System.Windows.Documents;
using CODE.Framework.Wpf.Mvvm;

namespace DocumentExamples.Models.Print
{
    public class CustomerWithFilterViewModel : ViewModel
    {
        private FlowDocument _document;

        public CustomerWithFilterViewModel()
        {
            Customers = new ObservableCollection<StandardViewModel>();

            var docResult = Controller.Action("Print", "CustomerList3", new {model = this}).Result as DocumentResult;
            if (docResult != null)
                Document = docResult.Document as FlowDocument;

            Refresh = new ViewAction(execute: (a, o) =>
                {
                    Customers.Clear();
                    for (var i = 0; i < 100; i++)
                        Customers.Add(new StandardViewModel
                            {
                                Text1 = "Customer #" + (i + 1),
                                Text2 = "6605 Cypresswood Dr.",
                                Text3 = "Suite 300",
                                Text4 = "Spring, TX 77379"
                            });
                });

            Actions.Add(new CloseCurrentViewAction(this, beginGroup: true));
        }

        public ObservableCollection<StandardViewModel> Customers { get; set; }

        public ViewAction Refresh { get; set; }

        public FlowDocument Document
        {
            get { return _document; }
            set
            {
                _document = value;
                NotifyChanged("Document");
            }
        }
    }
}
